int M1_in1 =3;
int M1_in2 =11;
int M2_in1 =9;
int M2_in2 =10;

int Smin =0;
int Smax =2;
int Step =3;
int Speed[3] = {100,200,255};
int Sp=0;

char str[20];
char val;

void Serial_gets(char *buf,char sw)
{
  int i = 0;
  char c;
  while (1) {
    if (Serial.available()) {
      c = Serial.read();
      //Serial.println(c);
      buf[i] = c;
      if (c == sw) break; // 文字列の終わり判断
      i++;
    }
  }
  buf[i] = '\0';
}

void setup() {
  Serial.begin(9600); // シリアルポートを9600bpsで開く
}

void motor_move1(int val) {
  if(val>0) {
  analogWrite(M1_in1,abs(val));
  analogWrite(M1_in2,0);
  }
  if(val<0) {
  analogWrite(M1_in2,abs(val));
  analogWrite(M1_in1,0);
  }
  if(val==0) {
  analogWrite(M1_in2,255);
  analogWrite(M1_in1,255);
  }
}

void motor_move2(int val) {
  if(val>0) {
  analogWrite(M2_in1,abs(val));
  analogWrite(M2_in2,0);
  }
  if(val<0) {
  analogWrite(M2_in2,abs(val));
  analogWrite(M2_in1,0);
  }
  if(val==0) {
  analogWrite(M2_in2,255);
  analogWrite(M2_in1,255);
  }
}

void Turn_R(int val) {
  motor_move1(val);
  motor_move2(-val);
}
void Turn_L(int val) {
  motor_move1(-val);
  motor_move2(val);
}

void Back(int val) {
  motor_move1(-val);
  motor_move2(-val);
}

void Go(int val) {
  motor_move1(val);
  motor_move2(val);
}

void Stop() {
  motor_move1(0);
  motor_move2(0);
}

void loop() {
  int i;
  Serial_gets(str,',');
  Serial.println(str);
  val = str[0];
  Serial.println(Sp);
  //Speed
  if(val == 'u') {
    if((Sp<Smax) && (Sp >= Smin)) {
      Sp=Sp+1;
    }
  }
  if(val == 'd') {
    if((Sp<=Smax) && (Sp > Smin)) {
      Sp=Sp-1;
    }
  }
  //Left or Rigt
  if(val == 'r') {
  Turn_R(Speed[Sp]);
  }
  if(val == 'l') {
  Turn_L(Speed[Sp]);
  }
  //back or go
  if(val == 'f') {
  Go(Speed[Sp]);
  }
  if(val == 'b') {
  Back(Speed[Sp]);
  }
  //Stop
  if(val == 's') {
  Stop();
  }
}
