#include "WProgram.h"
void Serial_gets(char *buf,char sw);
void setup();
void motor_move1(int val);
void motor_move2(int val);
void loop();
int M1_in1 =3;
int M1_in2 =11;
int M2_in1 =9;
int M2_in2 =10;

char str[20];
int val;

void Serial_gets(char *buf,char sw)
{
  int i = 0;
  char c;
  while (1) {
    if (Serial.available()) {
      c = Serial.read();
      //Serial.println(c);
      buf[i] = c;
      if (c == sw) break; // \u6587\u5b57\u5217\u306e\u7d42\u308f\u308a\u5224\u65ad
      i++;
    }
  }
  buf[i] = '\0';
}

void setup() {
  Serial.begin(9600); // \u30b7\u30ea\u30a2\u30eb\u30dd\u30fc\u30c8\u30929600bps\u3067\u958b\u304f
}

void motor_move1(int val) {
  if(val>0) {
  analogWrite(M1_in1,abs(val));
  analogWrite(M1_in2,0);
  }
  if(val<0) {
  analogWrite(M1_in2,abs(val));
  analogWrite(M1_in1,0);
  }
  if(val==0) {
  analogWrite(M1_in2,255);
  analogWrite(M1_in1,255);
  }
}

void motor_move2(int val) {
  if(val>0) {
  analogWrite(M2_in1,abs(val));
  analogWrite(M2_in2,0);
  }
  if(val<0) {
  analogWrite(M2_in2,abs(val));
  analogWrite(M2_in1,0);
  }
  if(val==0) {
  analogWrite(M2_in2,255);
  analogWrite(M2_in1,255);
  }
}

void loop() {
  int i;
  Serial_gets(str,',');
  val=atoi(str);
  motor_move1(val);
  motor_move2(val);
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

